# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Rules do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :RuleEnabledYN,
    :FieldKeyNumeric,
    :RuleKeyNumeric,
    :RuleOrder,
    :FieldKey,
    :FieldName,
    :OriginatingSystemID,
    :OriginatingSystemName,
    :OriginatingSystemRuleKey,
    :RuleAction,
    :RuleDescription,
    :RuleErrorText,
    :RuleExpression,
    :RuleHelpText,
    :RuleKey,
    :RuleName,
    :RuleVersion,
    :RuleWarningText,
    :SourceSystemHistoryKey,
    :SourceSystemID,
    :SourceSystemName,
    :ClassName,
    :ResourceName,
    :RuleFormat,
    :RuleType,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :OriginatingSystem,
    :SourceSystem
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :RuleEnabledYN => boolean() | nil,
    :FieldKeyNumeric => float() | nil,
    :RuleKeyNumeric => float() | nil,
    :RuleOrder => float() | nil,
    :FieldKey => String.t | nil,
    :FieldName => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemName => String.t | nil,
    :OriginatingSystemRuleKey => String.t | nil,
    :RuleAction => String.t | nil,
    :RuleDescription => String.t | nil,
    :RuleErrorText => String.t | nil,
    :RuleExpression => String.t | nil,
    :RuleHelpText => String.t | nil,
    :RuleKey => String.t | nil,
    :RuleName => String.t | nil,
    :RuleVersion => String.t | nil,
    :RuleWarningText => String.t | nil,
    :SourceSystemHistoryKey => String.t | nil,
    :SourceSystemID => String.t | nil,
    :SourceSystemName => String.t | nil,
    :ClassName => String.t | nil,
    :ResourceName => String.t | nil,
    :RuleFormat => String.t | nil,
    :RuleType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Rules do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
  end
end

